// $Header: /home/anthony/tolkien/include/RCS/charhpld.h,v 1.3 1996/06/19 02:19:53 anthony Exp $
//                                                                       
//      TOLKIEN: Tool Kit for Genetics-based Applications
//                                                                       
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1996.
//   
#if !defined(__CHARHPLD_H)
#define __CHARHPLD_H

#include <haploid.h>

class CharHaploid : public Haploid<char>
{
public:                            
        CharHaploid(int n, char c) : Haploid<char>(n,c) {}
        CharHaploid(const CharHaploid& src) : Haploid<char>(src) {}
        CharHaploid() : Haploid<char>(26,0)
        {
             char c = 'a';
             for (Haploid<char>::iterator i = begin(); i != end(); i++,c++)
                  *i = c;
        }

        CharHaploid* clone() const
        {
             return new CharHaploid(*this);
        }

        void mutate(double mrate)
        {
             vector<char>::iterator i, j;
             for (i = begin(); i != end(); i++)
                  if (flip(mrate)) {       
                      j = begin() + tRand.asLong(0,25);
                      swap(*i, *j);
                  }
        }        
        void randomize()
        {        
             mutate(1);
        }        
};

#endif

