// $Header: /home/anthony/tolkien/src/RCS/tgaobj.cc,v 1.2 1996/06/19 02:24:55 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
#include <limits.h>
#include <math.h>
#include <tgaobj.h>

hashValue_t TGAObj::hashValue() const
//
//
//      This hash function uses the address of the object as key and
//      mapped it to a value in [0, M - 1]. (see below for M)
//
//	The method used is the multiplication hashing described in Kunth's
//	The Art of Computer Programming, vol 3.
//
//      hashValue = floor( M * frac( Ak ) )
//
//	where A is the golden ratio ( 0.6180339887499 )
//	      k is the address of the object
//            M is a constant ( chosen to be HASH_MAX )
//
{	
	double integer;
	return (hashValue_t) floor(HASH_MAX * modf(((unsigned long) (TGAObj*) this) * 0.6180339887499, &integer));
}


