// $Header: /home/anthony/tolkien/src/RCS/tritstr1.cc,v 1.3 1996/06/19 02:24:55 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1996.
//
#include   <tritstr1.h>


void TritString::setRand(unsigned pos)
{
    if (mutateDC() == 0)
        genes[pos] = (genes[pos] + tRand(1,2) + 1) % 3 - 1;
    else 
        if (flip(mutateDC())) 
            genes[pos] = dontCare;
        else
            genes[pos] = tRand(0,1);
}

void TritString::mutate(double flMRate)
{
     for (int i=length()-1; i>=0; i--)
          if (flip(flMRate))
              setRand(i);
}

void TritString::randomize()
{
     for (int i=length()-1;i>=0;i--)
          setRand(i);
}

void TritString::printOn(ostream& out) const                               
{                
        for (int i = 0; i < length(); i++) {
             switch (genes[i]) {
                case 1: out << '1'; break;
                case 0: out << '0'; break;
                default : out << (char) dontCare; break;
             }
        }
        out << ' ';
        TGAObj::printOn(out);
}

void TritString::operator=(const BitString& bits)
{
        for (int i = 0; i < bits.length(); i++)
             genes[i] = bits.test(i);
}


